<?require_once($_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/main/include/prolog_before.php");
define('SITE_ID', "s1");
define("LOG_FILENAME", $_SERVER["DOCUMENT_ROOT"]."/bitrix/php_interface/log.txt");
//use Bitrix\Main\Application;
//$request = Application::getInstance()->getContext()->getRequest();


use Bitrix\Main\Web\Uri;
use \Bitrix\Main\UserTable;
use \Bitrix\Main;
use \Bitrix\Main\Loader;
use \Bitrix\Sale\Delivery;
use \Bitrix\Sale\PaySystem;
use \Bitrix\Sale;
use \Bitrix\Sale\Order;
use \Bitrix\Sale\DiscountCouponsManager;
use Bitrix\Main\Localization\Loc;

Bitrix\Main\Loader::includeModule("sale");


if(empty($_POST["phone"])){ 
    $result = "Введите телефон";
    echo json_encode($result);
}
else{   
    
    $name = $_POST["name"] ?? "Не заполнено";        
    $text = $_POST["text"] ?? ""; 
    $formName = $_POST["form_name"] ?? "Купить в 1 клик: ";       
    $description = $formName.": ".$_POST["phone"]." Имя: ".$name."\n".$text; 

    global $USER;
    if($USER->IsAuthorized()){
        $userId  = $USER->GetID();
        $email = $USER->GetEmail(); 
    }
    else{
        $userId = 20;
        $email = "one_click@mail.ru";
    }
    
    
    DiscountCouponsManager::init();
    $order = \Bitrix\Sale\Order::create(SITE_ID, $userId,"RUB");
    $order->setPersonTypeId(1);
    $basket = Sale\Basket::loadItemsForFUser(Sale\Fuser::getId(), SITE_ID);
    $order->setBasket($basket);
    $order->setField("USER_DESCRIPTION",$description);

    //доставка
    $shipmentCollection = $order->getShipmentCollection();
    $shipment = $shipmentCollection->createItem();
    $deliveryId = Delivery\Services\EmptyDeliveryService::getEmptyDeliveryServiceId(); //доставка "без доставки"

    $service = Delivery\Services\Manager::getById($deliveryId);
     
    $shipment->setFields(array(
        'DELIVERY_ID' => $service['ID'],
        'DELIVERY_NAME' => $service['NAME'],                         
    ));
    $shipmentItemCollection = $shipment->getShipmentItemCollection();
    foreach ($order->getBasket() as $item){
        $shipmentItem = $shipmentItemCollection->createItem($item);
        $shipmentItem->setQuantity($item->getQuantity());
    }
    //оплата
    $paymentCollection = $order->getPaymentCollection();
    $payment = $paymentCollection->createItem(\Bitrix\Sale\PaySystem\Manager::getObjectById(2)); //$paySystemId  - ИД платежной системы
    $payment->setField('SUM', $order->getPrice());

    $propertyCollection = $order->getPropertyCollection();
    if($property = $propertyCollection->getItemByOrderPropertyCode("NAME")){
        $property->setValue($name);
    }    
    if($property = $propertyCollection->getItemByOrderPropertyCode("PHONE")){
        $property->setValue($phone);
    }   
    if($property = $propertyCollection->getItemByOrderPropertyCode("EMAIL")){
        $property->setValue($email);
    }
   
    $order->doFinalAction(true);
     
    $error = false;  
    try {
        $resultOrder = $order->save(); 
    } catch (Exception $e) {
        AddMessage2Log($e->getMessage());
        $error = true; //$e->getMessage();      
         
    }
             
   
    if(!$error){    
        if ($resultOrder->isSuccess()) {
            $result = "ok";
           
            //$subject = $formName.' , заказ №'.$ORDER_ID;
        } 
        else {
            //$result =  $resultOrder->getError();            
            AddMessage2Log($resultOrder->getError());
            //$subject = $formName." ошибка при создании ".;
        }
    }
                
    $result = "ok";
    $GLOBALS['APPLICATION']->RestartBuffer();    
    echo json_encode($result);
    die();
}