<?if(!defined("B_PROLOG_INCLUDED")||B_PROLOG_INCLUDED!==true)die();?>
<div class="popup-overlay" id="phone-panel">
     <div class="popup-wrap">
        <button class="button-close popup-close" type="button"><i class="icon-close"></i></button>
        <div class="popup-header">
            <div class="figure"><i class="icon-message"></i></div>
            <span id="callback<?=$arParams["PREFIX"]?>-result-good"><?=$arParams["HEADER"]?></span>
            <p class="subtext"><?=$arParams["TEXT"]?></p>
            <p class="subtext" id="callback<?=$arParams["PREFIX"]?>-error"></p>
        </div>
        
        <form class="auth-form" action="/" id="callback-form">
            <?=bitrix_sessid_post()?>
            <input class="field-dark" type="text" placeholder="Представьтесь" id="callback-name" value="<?=$arResult["USER"]["FULL_NAME"] ?? ""?>">
            <input class="field-dark" type="phone" placeholder="Ваш телефон" id="callback-phone" value="<?=$arResult["USER"]["PHONE_NUMBER"] ?? ""?>">
            <button class="button-basic flex-center w-100" type="submit" id="callback-send">Отправить</button>
        </form>
    </div>
</div>



<script>    
    BX.ready(function(){
        $(".callback-button").on("click", function(e) {       
            e.preventDefault(); 
            $("#phone-panel").addClass("active-modal");
        });
        $("#callback-send").click(function(e){
            e.preventDefault(); 
            $('#callback-error').html("");           
            let phone = $("#callback-phone").val();            
            if((phone == "") || (phone.indexOf('_')>0)){
                $('#callback-error').html("Проверьте корректность телефона");                
            }
            else{
                postData = {
                    sessid: BX.bitrix_sessid(),
                    site_id: BX.message('SITE_ID'),
                    'phone': phone,
                    name: $('#callback-name').val(),
                    ajax_call: 'Y'
                };               
                BX.ajax({
                   url: '<?=$component->GetPath()?>/component.php',
                   method: 'POST',
                   data: postData,
                   dataType: 'json',                   
                   onsuccess: function(data){                        
                       if(data == "ok"){
                            $('#callback-result-good').html("Спасибо! Мы с Вами свяжемся!");
                            $('#callback-form').hide();
                            $('#phone-panel .subtext').hide();
                        }
                        else{
                            $('#callback-error').html(data);

                            
                        }
                   },
                   onfailure: function(error){
                      console.log(error);
                   } 
                });
                

            }
        });
    });    
</script>