<?if(!defined("B_PROLOG_INCLUDED")||B_PROLOG_INCLUDED!==true)die();
CJSCore::Init(array('ajax'));
?>
<div class="popup-overlay" id="phone-panel<?=$arParams["UNIQ_ID"]?>">
     <div class="popup-wrap">
        <button class="button-close popup-close" type="button"><i class="icon-close"></i></button>
        <div class="popup-header">
            <div class="figure"><i class="icon-message"></i></div>
            <span id="callback<?=$arParams["UNIQ_ID"]?>-result-good"><?=$arParams["HEADER"]?></span>
            <p class="subtext"><?=$arParams["TEXT"]?></p>
            <p class="subtext" id="callback<?=$arParams["UNIQ_ID"]?>-error"></p>
        </div>
        
        <form class="auth-form" action="/" id="callback<?=$arParams["UNIQ_ID"]?>-form">
            <?=bitrix_sessid_post()?>
            <input class="field-dark" type="text" placeholder="Представьтесь" id="callback<?=$arParams["UNIQ_ID"]?>-name" value="<?=$arResult["USER"]["FULL_NAME"] ?? ""?>">
            <input class="field-dark" type="phone" placeholder="Ваш телефон" id="callback<?=$arParams["UNIQ_ID"]?>-phone" value="<?=$arResult["USER"]["PHONE_NUMBER"] ?? ""?>">
            <?if($arParams["SHOW_TEXT"]=="Y"):?>
                <textarea class="field-dark" placeholder="Комментарий, адрес доставки, удобное время" id="callback<?=$arParams["UNIQ_ID"]?>-text"></textarea>
            <?endif;?>
            <button class="button-basic flex-center w-100" type="submit" id="callback<?=$arParams["UNIQ_ID"]?>-send">Отправить</button>
        </form>
    </div>
</div>
<script>
    BX.ready(function(){
       
            $(".callback-button<?=$arParams["PREFIX"]?>").on("click", function(e) {       
                e.preventDefault();
                $("#callback<?=$arParams["UNIQ_ID"]?>-send").data("id",$(e.target).data('id'));
                $("#phone-panel<?=$arParams["UNIQ_ID"]?>").addClass("active-modal");
            });
           $("#callback<?=$arParams["UNIQ_ID"]?>-send").click(function(e){
                e.preventDefault(); 
               
                $('#callback<?=$arParams["UNIQ_ID"]?>-error').html("");           
                let phone = $("#callback<?=$arParams["UNIQ_ID"]?>-phone").val();            
                if((phone == "") || (phone.indexOf('_')>0)){
                    $('#callback<?=$arParams["UNIQ_ID"]?>-error').html("Проверьте корректность телефона");                
                }
                else{
                    let postData = {
                        sessid: BX.bitrix_sessid(),
                        site_id: BX.message('SITE_ID'),
                        phone: phone,
                        name: $('#callback<?=$arParams["UNIQ_ID"]?>-name').val(),
                        ajax_call: 'Y',
                        form_name: "<?=$arParams["HEADER"]?>",
                        text: $('#callback<?=$arParams["UNIQ_ID"]?>-text').val(),
                        ids: [$(e.target).data('id')]
                    };               
                    BX.ajax({
                       url: '<?=$component->GetPath()?>/component.php',
                       method: 'POST',
                       data: postData,
                       dataType: 'json',                   
                       onsuccess: function(data){                        
                           if(data == "ok"){
                                $('#callback<?=$arParams["UNIQ_ID"]?>-result-good').html("Спасибо! Мы с Вами свяжемся!");
                                $('#callback<?=$arParams["UNIQ_ID"]?>-form').hide();
                                $('#phone-panel<?=$arParams["UNIQ_ID"]?> .subtext').hide();
                            }
                            else{
                                $('#callback<?=$arParams["UNIQ_ID"]?>-error').html(data);                                
                            }
                       },
                       onfailure: function(error){
                          console.log(error);
                       } 
                    });
                    

                }
            });
        
    });   
</script>